/*
 * 本範程式為Arduino結合L298N擴展板的範例程式，由傑森創工提供
 * 
 * 購買L298N擴展板：
 * https://www.jmaker.com.tw/products/l298p
 * 
 * 粉絲團：https://www.facebook.com/jasonshow
 * 傑森創工購物網：https://www.jmaker.com.tw/
 * 傑森創工部落格：https://blog.jmaker.com.tw/
 */

int E1 = 10;  //右輪馬達轉速 
int M1 = 12;  //右輪馬達方向 
int E2 =11;   //左輪馬達轉速                    
int M2 = 13;  //左輪馬達方向     

byte motorSpeed = 160;
 
void setup()
{
    pinMode(M1, OUTPUT); 
    pinMode(M2, OUTPUT);
}
 


void forward() {  // 前進
  //右輪
  digitalWrite(M1, HIGH);
  analogWrite(E1, motorSpeed);
  
  //左輪。因在小車上馬達安裝方向左右兩個是相反的，所以另一隻馬達的設定要相反，兩輪才能配合。）
  digitalWrite(M2, LOW);
  analogWrite(E2, motorSpeed);
}

void backward() {  // 後退
  //右輪
  digitalWrite(M1, LOW);
  analogWrite(E1, motorSpeed);
  
  //左輪。因在小車上馬達安裝方向左右兩個是相反的，所以另一隻馬達的設定要相反，兩輪才能配合。）
  digitalWrite(M2, HIGH);
  analogWrite(E2, motorSpeed);
}

void turnLeft() { // 左轉
  //左輪不動（速度為0），右輪動
  
  analogWrite(E2, 0);
  
  digitalWrite(M1, HIGH);
  analogWrite(E1, motorSpeed);
}

void turnRight() {  // 右轉
  //右輪不動（速度為0），左輪動
  
  analogWrite(E1, 0);
  
  digitalWrite(M2, LOW);
  analogWrite(E2, motorSpeed);
}

void stopMotor() {  //停止，兩輪速度為0
  
  analogWrite(E1, 0);

  analogWrite(E2, 0);
}


void loop() {
  //本範例會讓車子向前、向後、向左、向右、停止，各2秒，然後不斷重複
  
  forward();
  delay(2000);
  backward();
  delay(2000);
  turnLeft();
  delay(2000);
  turnRight();
  delay(2000);
  stopMotor();
  delay(2000);
}
